
local tinsert = tinsert
local tremove = tremove

local function tcount(tab)
	local n = 0
	if tab then
		for _ in pairs(tab) do
			n = n + 1
		end
	end
	return n
end

local RHS_COLOR1 = {250/255, 213/255,  62/255}
local RHS_COLOR2 = { 90/255,  90/255,  90/255}
local RHS_COLOR3 = {243/255, 244/255, 255/255}
local RHS_COLOR4 = { 25/255, 118/255, 210/255} 
local RHS_FONT = UNIT_NAME_FONT
local MEDIA_PATH = "Interface\\AddOns\\RandomHearthstone\\Media\\"

local MacroVersion = 4
local ListVersion = 6

----------------------------------------------------------------
--> List
----------------------------------------------------------------

local HearthStoneList = {
	162973,	--冬天爷爷的炉石 278244
	163045,	--无头骑士的炉石 278559
	165669,	--春节长者的炉石 285362
	165670,	--小匹德菲特的可爱炉石
	166746, --吞火者的炉石
	166747, --美酒节狂欢者的炉石
	165802,	--复活节的炉石
	64488,	--旅店老板的女儿
	93672,	--黑暗之门
	54452,	--虚灵之门
	142542,	--城镇传送门 231504
	168907, --全息数字化炉石
	172179, --永恒旅者的炉石

	180290, --法夜炉石
	182773, --通灵领主炉石
	183716, --温西尔罪碑
	184353, --格里恩炉石
}
--6948, --炉石 8690

local HearthStoneListChecked = {}

----------------------------------------------------------------
--> HearthStone
----------------------------------------------------------------
local function ButtonHighLight(frame)
	local PlusHighlight = frame:CreateTexture(nil, "OVERLAY")
	PlusHighlight: SetTexture(MEDIA_PATH.."Tile1")
	PlusHighlight: SetVertexColor(unpack(RHS_COLOR3))
	PlusHighlight: SetAllPoints(frame)
	PlusHighlight: SetAlpha(0)

	frame: HookScript("OnEnter", function(self)
		PlusHighlight: SetAlpha(0.4)
	end)
	frame: HookScript("OnLeave", function(self)
		PlusHighlight: SetAlpha(0)
	end)
end

local function Macro_Refresh(name, nameused, reset)
	local MacroName = GetMacroInfo("RHS")
	name = name or GetItemInfo(6948)
	if (not name) or (InCombatLockdown()) then return end
	if (not nameused) then nameused = name end
	if (not MacroName) then
		local gNum, pNum = GetNumMacros()
		if (gNum == 72) then return end
		local macroID = CreateMacro("RHS", "INV_MISC_QUESTIONMARK", "#showtooltip "..name..
[[

/click RandomHearthStone
/rhs check
]], nil, 1)
		DEFAULT_CHAT_FRAME:AddMessage("Macro RHS has be created.")
	elseif reset then
		local macroID = EditMacro("RHS", "RHS", "INV_MISC_QUESTIONMARK", "#showtooltip "..name..
[[

/click RandomHearthStone
/rhs check
]])
		DEFAULT_CHAT_FRAME:AddMessage("Macro RHS has be reseted.")
	else
		local body = GetMacroBody("RHS")
		local startPos, endPos, firstWord, restOfString = string.find(body, nameused)
		if not (startPos or endPos) then
			startPos, endPos, firstWord, restOfString = string.find(body, name)
		end
		if startPos and endPos then
			local macroID = EditMacro("RHS", "RHS", "INV_MISC_QUESTIONMARK", string.sub(body, 1, startPos-1)..name..string.sub(body, endPos+1))
		else
			startPos, endPos, firstWord, restOfString = string.find(body, "#showtooltip .-%c")
			--local startPos, endPos, firstWord, restOfString = string.find(body, "^.-%c")
			if endPos then
				local macroID = EditMacro("RHS", "RHS", "INV_MISC_QUESTIONMARK", "#showtooltip "..name..string.sub(body, endPos))
			end
		end
	end
end

local function Macro_CreatePro(name)
	local MacroName = GetMacroInfo("RHS")
	--name = name or GetItemInfo(6948)
	name = name or "item:6948"
	if (not name) or (InCombatLockdown()) then return end
	if (not MacroName) then
		local macroID = CreateMacro("RHS", "INV_MISC_QUESTIONMARK", "#showtooltip", nil, 1)
	else
		local macroID = EditMacro("RHS", "RHS", "INV_MISC_QUESTIONMARK", "#showtooltip")
	end

	--local DALARAN = GetItemInfo(140192) or ""
	local DALARAN = "item:140192" or ""
	--local GARRISON = GetItemInfo(110560) or ""
	local GARRISON = "item:110560" or ""
	--local WHISTLE = GetItemInfo(141605) or ""
	local WHISTLE = "item:141605" or ""

	local macroID = EditMacro("RHS", "RHS", "INV_MISC_QUESTIONMARK", "#showtooltip [nomod]"..name..";[mod:shift]"..DALARAN..";[mod:ctrl]"..GARRISON..";[mod:alt]"..WHISTLE..[[

]].."/cast [mod:shift]"..DALARAN.."\r/cast [mod:ctrl]"..GARRISON.."\r/cast [mod:alt]"..WHISTLE.."\r/stopmacro [mod] \r/click RandomHearthStone \r/rhs check")

	DEFAULT_CHAT_FRAME:AddMessage("Macro RHS has be updated.")
end

local function HearthStoneToUse_UpdateList()
	for k, v in ipairs(HearthStoneList) do
		if PlayerHasToy(v) then
			tinsert(HearthStoneListChecked, {ID = v})
		end
	end
	local num = #HearthStoneListChecked
	if num and num >=1 then
		for k, v in ipairs(HearthStoneListChecked) do
			--local name = GetItemInfo(v.ID)
			local name = "item:"..v.ID
			if name then
				HearthStoneListChecked[k].Name = name
			end
		end
	end
end

local function HearthStoneList_Update()
	if not RandomHearthstone_DB.HearthStoneList then
		RandomHearthstone_DB.HearthStoneList = {}
	end
	for k,v in ipairs(HearthStoneListChecked) do
		if not RandomHearthstone_DB.HearthStoneList[v.ID] then
			RandomHearthstone_DB.HearthStoneList[v.ID] = {}
			RandomHearthstone_DB.HearthStoneList[v.ID].Enable = true
			--RandomHearthstone_DB.HearthStoneList[v.ID].Name = v.Name
		end
		--if not RandomHearthstone_DB.HearthStoneList[v.ID].Name then
		--	RandomHearthstone_DB.HearthStoneList[v.ID].Name = v.Name
		--end
	end
end

local function RandomList_Update()
	if not RandomHearthstone_DB.RandomList then
		RandomHearthstone_DB.RandomList = {}
	end
	table.wipe(RandomHearthstone_DB.RandomList)
	for k,v in pairs(RandomHearthstone_DB.HearthStoneList) do
		if v.Enable == true then
			tinsert(RandomHearthstone_DB.RandomList, "item:"..k)
		end
	end
end

local function HearthStoneToUse_Random(frame)
	if not RandomHearthstone_DB.RandomList then
		RandomList_Update()
	end
	if tcount(RandomHearthstone_DB.RandomList) == 0 then
		RandomList_Update()
	end
	if (not InCombatLockdown()) then
		local num = tcount(RandomHearthstone_DB.RandomList)
		if num >= 1 then
			rnum = random(num)
			HearthStoneToUse = RandomHearthstone_DB.RandomList[rnum] or "item:6948" or GetItemInfo(6948)
			frame: SetAttribute("item", HearthStoneToUse)
			frame.NeedToEditMacro = true
			--Macro_Refresh(HearthStoneToUse)
			RandomHearthstone_DB.HearthStoneUsed = RandomHearthstone_DB.HearthStoneToUse
			RandomHearthstone_DB.HearthStoneToUse = HearthStoneToUse
			tremove(RandomHearthstone_DB.RandomList, rnum)
		end
		frame.NeedToRandom = false
	else
		frame.NeedToRandom = true
	end
end

local function HearthStoneToUse_Check(frame)
	if RandomHearthstone_DB and (not RandomHearthstone_DB.HearthStoneToUse) then
		HearthStoneToUse_Random(frame)
	end
end

function RHS_HearthStoneList_Load(frame)
	local noname = false
	HearthStoneToUse_UpdateList()
	for k, v in ipairs(HearthStoneListChecked) do
		if not HearthStoneListChecked[k].Name then
			noname = true
		end
	end
	--if (tcount(HearthStoneListChecked) == 0) or noname then
	if noname then
		C_Timer.After(2, function()
			RHS_HearthStoneList_Load(frame)
		end)
	else
		HearthStoneList_Update()
		HearthStoneToUse_Check(frame)
	end
end

local function HearthStoneToUse_Init(frame)
	if RandomHearthstone_DB and RandomHearthstone_DB.HearthStoneToUse then
		frame: SetAttribute("item", RandomHearthstone_DB.HearthStoneToUse)
	end
end

local function HearthStoneToUse_New(frame, arg)
	for k, v in ipairs(HearthStoneList) do
		if arg == v then
			if RandomHearthstone_DB and PlayerHasToy(v) then
				--RandomHearthstone_DB.HearthStoneToUse = GetItemInfo(v)
				RandomHearthstone_DB.HearthStoneToUse = "item:"..v
			end
		end
	end
end

local function RHS_IOF_Artwork(frame)
	local Logo = frame:CreateFontString(nil, "ARTWORK")
	Logo: SetFont(RHS_FONT, 20, nil)
	Logo: SetTextColor(unpack(RHS_COLOR1))
	Logo: SetPoint("TOPLEFT", frame, "TOPLEFT", 10,-10)
	Logo: SetText("Random HearthStone")

	local VersionText = frame:CreateFontString(nil, "ARTWORK")
	VersionText: SetFont(RHS_FONT, 14, nil)
	VersionText: SetPoint("TOPLEFT", Logo, "BOTTOMLEFT", 0,-4)
	VersionText: SetText("Version: "..GetAddOnMetadata("RandomHearthstone", "Version"))

	local Hold1 = CreateFrame("Frame", nil, frame, "BackdropTemplate")
	Hold1: SetSize(240,100)
	Hold1: SetPoint("TOPLEFT", frame, "TOPLEFT", 22,-80)
	Hold1: SetBackdrop({
		bgFile = MEDIA_PATH.."Tile2",
		edgeFile = MEDIA_PATH.."Tile1",
		tile = false, tileSize = 8, edgeSize = 2,
		insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	Hold1: SetBackdropColor(0,0,0,0)
	Hold1: SetBackdropBorderColor(unpack(RHS_COLOR2))

	MacroText1 = frame:CreateFontString(nil, "ARTWORK")
	MacroText1: SetFont(RHS_FONT, 12, nil)
	MacroText1: SetSize(230,60)
	MacroText1: SetPoint("TOPLEFT", Hold1, "TOPLEFT", 5,-5)
	MacroText1: SetJustifyH("LEFT")
	MacroText1: SetJustifyV("TOP")

	local CreateMacro = CreateFrame("Button", nil, frame, "BackdropTemplate")
	CreateMacro: SetSize(232,26)
	CreateMacro: SetPoint("BOTTOM", Hold1, "BOTTOM", 0,4)
	CreateMacro: SetBackdrop({
		bgFile = MEDIA_PATH.."Tile2",
		edgeFile = MEDIA_PATH.."Tile1",
		tile = false, tileSize = 8, edgeSize = 1,
		insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	CreateMacro: SetBackdropColor(unpack(RHS_COLOR4))
	CreateMacro: SetBackdropBorderColor(0,0,0,0)
	ButtonHighLight(CreateMacro)
	CreateMacro: SetScript("OnClick", function(self, mbtn)
		Macro_Refresh(RandomHearthstone_DB.HearthStoneToUse, RandomHearthstone_DB.HearthStoneToUse, true)
		PickupMacro("RHS")
	end)

	ButtonText1 = CreateMacro:CreateFontString(nil, "ARTWORK")
	ButtonText1: SetFont(RHS_FONT, 14, nil)
	ButtonText1: SetPoint("CENTER", CreateMacro, "CENTER")
	ButtonText1: SetText(ADD.." / "..RESET)

	local Hold2 = CreateFrame("Frame", nil, frame, "BackdropTemplate")
	Hold2: SetSize(240,200)
	Hold2: SetPoint("TOPLEFT", frame, "TOPLEFT", 22,-200)
	Hold2: SetBackdrop({
		bgFile = MEDIA_PATH.."Tile2",
		edgeFile = MEDIA_PATH.."Tile1",
		tile = false, tileSize = 8, edgeSize = 2,
		insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	Hold2: SetBackdropColor(0,0,0,0)
	Hold2: SetBackdropBorderColor(unpack(RHS_COLOR2))

	MacroText2 = frame:CreateFontString(nil, "ARTWORK")
	MacroText2: SetFont(RHS_FONT, 12, nil)
	MacroText2: SetSize(230,160)
	MacroText2: SetPoint("TOPLEFT", Hold2, "TOPLEFT", 5,-5)
	MacroText2: SetJustifyH("LEFT")
	MacroText2: SetJustifyV("TOP")

	local CreateMacroPro = CreateFrame("Button", nil, frame, "BackdropTemplate")
	CreateMacroPro: SetSize(232,26)
	CreateMacroPro: SetPoint("BOTTOM", Hold2, "BOTTOM", 0,4)
	CreateMacroPro: SetBackdrop({
		bgFile = MEDIA_PATH.."Tile2",
		edgeFile = MEDIA_PATH.."Tile1",
		tile = false, tileSize = 8, edgeSize = 1,
		insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	CreateMacroPro: SetBackdropColor(unpack(RHS_COLOR4))
	CreateMacroPro: SetBackdropBorderColor(0,0,0,0)
	ButtonHighLight(CreateMacroPro)
	CreateMacroPro: SetScript("OnClick", function(self, mbtn)
		Macro_CreatePro(RandomHearthstone_DB.HearthStoneToUse)
		PickupMacro("RHS")
	end)

	ButtonText2 = CreateMacroPro:CreateFontString(nil, "ARTWORK")
	ButtonText2: SetFont(RHS_FONT, 14, nil)
	ButtonText2: SetPoint("CENTER", CreateMacroPro, "CENTER")
	ButtonText2: SetText(ADD.." / "..RESET)

	frame.Macro1Text = MacroText1
	frame.Macro2Text = MacroText2
end

local function RHS_IOF_Scroll(frame)
	local Scroll = CreateFrame("ScrollFrame", nil, frame)
	Scroll: SetSize(300,550)
	Scroll: SetPoint("TOPRIGHT", frame, "TOPRIGHT", -30, -10)

	local Gap = Scroll:CreateTexture(nil, "ARTWORK")
	Gap: SetTexture(MEDIA_PATH.."Tile1")
	Gap: SetVertexColor(unpack(RHS_COLOR2))
	Gap: SetPoint("TOPRIGHT", Scroll, "TOPLEFT", -10,-2)
	Gap: SetPoint("BOTTOMLEFT", Scroll, "BOTTOMLEFT", -12,2)
	Gap: SetAlpha(1)

	local Slider = CreateFrame("Slider", nil, Scroll)
	Slider: SetOrientation("VERTICAL")
	Slider: SetThumbTexture(MEDIA_PATH.."Slider", "ARTWORK")
	Slider: SetSize(18,544)
	Slider: SetPoint("LEFT", Scroll, "RIGHT", 5, 0)
	Slider: SetMinMaxValues(0, 1)
	Slider: SetValue(0)
	Slider: SetValueStep(1)
	Slider: Enable()
	Slider: Hide()
	
	local SliderBg = Slider:CreateTexture(nil, "BACKGROUND", 0)
	SliderBg: SetTexture(MEDIA_PATH.."Tile1")
	SliderBg: SetVertexColor(unpack(RHS_COLOR2))
	SliderBg: SetSize(6, 544)
	SliderBg: SetPoint("CENTER", Slider, "CENTER", 0,0)
	SliderBg: SetAlpha(1)
	
	Slider: SetScript("OnValueChanged", function(self)
		Scroll: SetVerticalScroll(self:GetValue())
	end)

	local Hold = CreateFrame("Frame", nil, Scroll)
	Hold: SetSize(300, 390)
	Hold: SetPoint("TOP")
	--Hold: Show()
	Scroll: SetScrollChild(Hold)
	Scroll: EnableMouseWheel(true)
	Scroll: SetScript("OnMouseWheel", function(self, d)
		local maxRange = self: GetVerticalScrollRange()
		local Range = self: GetVerticalScroll()
		Range = max(min(Range - d*10, maxRange), 0)
		self: SetVerticalScroll(Range)
		Slider: SetValue(Range)
	end)

	local Bars = {}

	frame.Scroll = Scroll
	frame.Scroll.Hold = Hold
	frame.Scroll.Bars = Bars
	frame.Scroll.Slider = Slider
end

local function RHS_IOF_Scroll_BarTemplate(frame)
	local Bar = CreateFrame("Frame", nil, frame.Hold)
	Bar: SetSize(300, 26)
	if frame.Num == 1 then
		Bar: SetPoint("TOP", frame.Hold, "TOP", 0,-2)
	else
		Bar: SetPoint("TOP", frame.Bars[frame.Num-1], "BOTTOM", 0,-4)
	end

	local Button = CreateFrame("Button", nil, Bar, "BackdropTemplate")
	Button: SetSize(52, 26)
	Button: SetPoint("TOPRIGHT", Bar, "TOPRIGHT", 0,0)
	Button: SetBackdrop({
		bgFile = MEDIA_PATH.."Tile2",
		edgeFile = MEDIA_PATH.."Tile1",
		tile = false, tileSize = 8, edgeSize = 1,
		insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	Button: SetBackdropColor(unpack(RHS_COLOR4))
	Button: SetBackdropBorderColor(0,0,0,0)

	Button: SetScript("OnEnter", function(self)
		GameTooltip: SetOwner(self, "ANCHOR_NONE", 0,0)
		GameTooltip: SetPoint("TOPLEFT", self, "TOPRIGHT", 4,0)
		GameTooltip: SetText(ENABLE.."/"..DISABLE)
		GameTooltip: Show()
	end)
	Button: SetScript("OnLeave", function(self)
		GameTooltip: Hide()
	end)
	ButtonHighLight(Button)

	local Block = CreateFrame("Frame", nil, Button, "BackdropTemplate")
	Block: SetSize(20,20)
	Block: SetPoint("CENTER", Button, "CENTER", 12,0)
	Block: SetBackdrop({
		bgFile = MEDIA_PATH.."Tile2",
		edgeFile = MEDIA_PATH.."Tile1",
		tile = false, tileSize = 16, edgeSize = 2,
		insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	Block: SetBackdropColor(unpack(RHS_COLOR3))
	Block: SetBackdropBorderColor(unpack(RHS_COLOR2))

	local Bg = Bar:CreateTexture(nil, "BACKGROUND", 1)
	Bg: SetTexture(MEDIA_PATH.."Tile1")
	Bg: SetVertexColor(unpack(RHS_COLOR2))
	Bg: SetHeight(26)
	Bg: SetPoint("TOPLEFT", Bar, "TOPLEFT", 0,0)
	Bg: SetPoint("TOPRIGHT", Button, "TOPLEFT", -4,0)

	local Name = Bar:CreateFontString(nil, "ARTWORK")
	Name: SetFont(RHS_FONT, 14, nil)
	Name: SetShadowColor(0,0,0,0.9)
	Name: SetShadowOffset(1,-1)
	Name: SetTextColor(unpack(RHS_COLOR3))
	Name: SetPoint("LEFT", Bg, "LEFT", 10, 0)

	Bar.Name = Name
	Bar.Button = Button
	Bar.Button.Block = Block

	return Bar
end

local function BarButton_BlockUpdate(frame, arg)
	if arg then
		frame.Button.Block: SetPoint("CENTER", frame.Button, "CENTER", 12,0)
		frame.Button: SetBackdropColor(unpack(RHS_COLOR4))
		frame.Button.Block: SetBackdropBorderColor(unpack(RHS_COLOR2))
	else
		frame.Button.Block: SetPoint("CENTER", frame.Button, "CENTER", -12,0)
		frame.Button: SetBackdropColor(unpack(RHS_COLOR2))
		frame.Button.Block: SetBackdropBorderColor(unpack(RHS_COLOR4))
	end
end

local function BarButton_SetUpClick(frame)
	frame.Button: SetScript("OnClick", function(self, mousebutton)
		if frame.ID and RandomHearthstone_DB.HearthStoneList[frame.ID] then
			if RandomHearthstone_DB.HearthStoneList[frame.ID].Enable then
				RandomHearthstone_DB.HearthStoneList[frame.ID].Enable = false
			else
				RandomHearthstone_DB.HearthStoneList[frame.ID].Enable = true
			end
			BarButton_BlockUpdate(frame, RandomHearthstone_DB.HearthStoneList[frame.ID].Enable)
			RandomList_Update()
		end
	end)
end

local function RHS_IOF_Scroll_Refresh(frame)
	frame.Num = 0
	for k, v in ipairs(HearthStoneList) do
		if RandomHearthstone_DB.HearthStoneList[v] then
			frame.Num = frame.Num + 1
			if not frame.Bars[frame.Num] then
				frame.Bars[frame.Num] = RHS_IOF_Scroll_BarTemplate(frame)
				BarButton_SetUpClick(frame.Bars[frame.Num])
			end
			frame.Bars[frame.Num]: Show()
			frame.Bars[frame.Num].ID = v
			frame.Bars[frame.Num].Name: SetText(GetItemInfo(v))
			BarButton_BlockUpdate(frame.Bars[frame.Num], RandomHearthstone_DB.HearthStoneList[v].Enable)
		end
	end
	local FrameNum = tcount(frame.Bars)
	if FrameNum > frame.Num then
		for i = (frame.Num+1), FrameNum do
			if frame.Bars[i] then
				frame.Bars[i]: Hide()
			end
		end
	end
	frame.Hold: SetHeight(2+30*frame.Num)
	frame.Slider: SetMinMaxValues(0, 2+30*frame.Num)
	frame: SetVerticalScroll(0)
end

local function RHS_IOF_Refresh(frame)
	frame.Macro1Text:SetText("#showtooltip "..RandomHearthstone_DB.HearthStoneToUse..
[[

/click RandomHearthStone
/rhs check
]]
	)

	--local DALARAN = GetItemInfo(140192) or ""
	local DALARAN = "item:140192" or ""
	--local GARRISON = GetItemInfo(110560) or ""
	local GARRISON = "item:110560" or ""
	--local WHISTLE = GetItemInfo(141605) or ""
	local WHISTLE = "item:141605" or ""
	frame.Macro2Text:SetText("#showtooltip [nomod]"..RandomHearthstone_DB.HearthStoneToUse..";[mod:shift]"..DALARAN..";[mod:ctrl]"..GARRISON..";[mod:alt]"..WHISTLE..[[

]].."/cast [mod:shift]"..DALARAN.."\r/cast [mod:ctrl]"..GARRISON.."\r/cast [mod:alt]"..WHISTLE.."\r/stopmacro [mod] \r/click RandomHearthStone \r/rhs check")
end

local function RHS_InterfaceOptions(frame)
	frame.OptionsPanel = CreateFrame("Frame", nil, UIParent)
	frame.OptionsPanel: SetSize(396,400)
	frame.OptionsPanel: Hide()

	RHS_IOF_Artwork(frame.OptionsPanel)
	RHS_IOF_Scroll(frame.OptionsPanel)
	RHS_IOF_Scroll_Refresh(frame.OptionsPanel.Scroll)
	RHS_IOF_Refresh(frame.OptionsPanel)
	frame.OptionsPanel: SetScript("OnShow", function(self)
		RHS_IOF_Scroll_Refresh(frame.OptionsPanel.Scroll)
		RHS_IOF_Refresh(frame.OptionsPanel)
	end)

	frame.OptionsPanel.name = "RandomHearthStone"
	InterfaceOptions_AddCategory(frame.OptionsPanel)
end

local RandomHearthStone = CreateFrame("Button", "RandomHearthStone", nil, "SecureActionButtonTemplate")
RandomHearthStone: SetAttribute("type","item")
RandomHearthStone: SetAttribute("item", GetItemInfo(6948))
RandomHearthStone.NeedToRandom = false
RandomHearthStone.NeedToEditMacro = false

RandomHearthStone: RegisterEvent("PLAYER_LOGIN")
RandomHearthStone: RegisterEvent("NEW_TOY_ADDED")
RandomHearthStone: RegisterEvent("TOYS_UPDATED")
RandomHearthStone: RegisterUnitEvent("UNIT_SPELLCAST_STOP", "player")
RandomHearthStone: RegisterUnitEvent("UNIT_SPELLCAST_FAILED", "player")
RandomHearthStone: RegisterUnitEvent("UNIT_SPELLCAST_INTERRUPTED", "player")
RandomHearthStone: RegisterEvent("PLAYER_REGEN_ENABLED")
RandomHearthStone: SetScript("OnEvent", function(self, event, arg)
	if event == "PLAYER_LOGIN" then
		if not RandomHearthstone_DB then
			RandomHearthstone_DB = {}
			RandomHearthstone_DB.MacroVersion = MacroVersion
			RandomHearthstone_DB.ListVersion = ListVersion
			RandomHearthstone_DB.HearthStoneList = {}
		end
		RHS_HearthStoneList_Load(self)
		HearthStoneToUse_Init(self)
		Macro_Refresh(RandomHearthstone_DB.HearthStoneToUse, RandomHearthstone_DB.HearthStoneUsed)
		if (not RandomHearthstone_DB.MacroVersion) or (RandomHearthstone_DB.MacroVersion < MacroVersion) then
			Macro_Refresh(RandomHearthstone_DB.HearthStoneToUse, RandomHearthstone_DB.HearthStoneUsed, true)
			RandomHearthstone_DB.MacroVersion = MacroVersion
		end
		if (not RandomHearthstone_DB.ListVersion) or (RandomHearthstone_DB.ListVersion < ListVersion) then
			RandomList_Update()
			RandomHearthstone_DB.ListVersion = ListVersion
		end
		RHS_InterfaceOptions(self)
	elseif event == "NEW_TOY_ADDED" then
		HearthStoneToUse_UpdateList()
		HearthStoneList_Update()
		HearthStoneToUse_New(frame, arg)
		Macro_Refresh(RandomHearthstone_DB.HearthStoneToUse, RandomHearthstone_DB.HearthStoneUsed)
	elseif event == "PLAYER_REGEN_ENABLED" then
		if self.NeedToRandom == true then
			HearthStoneToUse_Random(RandomHearthStone)
			Macro_Refresh(RandomHearthstone_DB.HearthStoneToUse, RandomHearthstone_DB.HearthStoneUsed)
			self.NeedToEditMacro = false
		end
	elseif event == "UNIT_SPELLCAST_STOP" or event == "UNIT_SPELLCAST_FAILED" or event == "UNIT_SPELLCAST_INTERRUPTED" then
		if self.NeedToEditMacro == true then
			Macro_Refresh(RandomHearthstone_DB.HearthStoneToUse, RandomHearthstone_DB.HearthStoneUsed)
			self.NeedToEditMacro = false
		end
	end
end)

SlashCmdList["RHS"] = function(msg)
	if msg == "check" then
		HearthStoneToUse_Random(RandomHearthStone)
	else
		RHS_HearthStoneList_Load(RandomHearthStone)
		Macro_Refresh(RandomHearthstone_DB.HearthStoneToUse, RandomHearthstone_DB.HearthStoneUsed, true)
	end
end
SLASH_RHS1 = "/rhs"
